C----------------------------------------------------------------------------
cc      
cc    mean, sigma
cc 
      subroutine calsig(v,d,m,s)
      implicit none
      integer NMAX
      parameter (NMAX=1000000)
      real*4 v(NMAX),m,s,sm,mt,mt0
      integer d,j
      
     
      sm=0.
      mt=0.       
      do j=1,d,1
        sm=sm+v(j)
      enddo

      m=sm/d
      do j=1,d,1
        mt0=((v(j)-m)**2)/(d-1)
        mt=mt+mt0
      enddo      
      s=mt**0.5
      
      if(d.eq.1)s=0.     
       
      end subroutine

C----------------------------------------------------------------------------    
cc      
cc    median, sigma
cc
 
      subroutine calsig2(v,d,md0,qs)
      implicit none
      integer NMAX
      parameter (NMAX=1000000)
      real*4 v(NMAX),md0,q1,q2,qs
      real*4 df,dg
      integer d,j,jj
      

      call sort1(d,v)
      if(mod(d,2).eq.0)then
         md0=( v(d/2) + v(d/2 + 1) ) / 2         !EVEN
	 
	   df=abs((0.25*d) - int(0.25*d))
	   if(df.ge.0.5)q1=v(1 + int(0.25*d))
	   if(df.lt.0.5)q1=v(int(0.25*d))
	   
	   dg=abs((0.75*d) - int(0.75*d))
	   if(dg.ge.0.5)q2=v(1 + int(0.75*d))
	   if(dg.lt.0.5)q2=v(int(0.75*d))
	   
         qs=(q2-q1)/2	 	 
      else
	 md0=v((d+1)/2)
	 
	   df=abs((0.25*d) - int(0.25*d))
	   if(df.ge.0.5)q1=v(1 + int(0.25*d))
	   if(df.lt.0.5)q1=v(int(0.25*d))
	   
	   dg=abs((0.75*d) - int(0.75*d))
	   if(dg.ge.0.5)q2=v(1 + int(0.75*d))
	   if(dg.lt.0.5)q2=v(int(0.75*d))
	   
         qs=(q2-q1)/2	 
      endif	
      
      if(d.eq.1)qs=0.     
     
      end subroutine


C----------------------------------------------------------- subroutine to sort 1 vector


      subroutine sort1(npt,x1)
      implicit none
      integer NM,nn,i,j,k,l,lognb2,m
      parameter (NM=1000000)
      integer npt
      real*4 x1(NM),t1
      real*8 val1, val2
            
                   
      val1 = 1.0/0.69314718
      val2 = 1.0e-5
      lognb2 = int(dlog(dfloat(npt))*val1+val2)
      m = npt
      
      do nn=1,lognb2
         m = m/2
         k = npt - m
         do j=1,k
            i = j
3           continue
            l = i + m
            if(x1(l).lt.x1(i)) then
               t1 = x1(i)	       
	       x1(i)=x1(l)	       
	       x1(l)=t1
               i = i - m
               if(i.ge.1)goto 3
            endif
         enddo
      enddo
            
      return      
      end subroutine
     

C----------------------------------------------------------- subroutine to sort 2 vectors


      subroutine sort2(npt,x1,x2)
      implicit none
      integer NM,nn,i,j,k,l,lognb2,m
      parameter (NM=1000000)
      integer npt
      real*4 x1(NM),x2(NM)
      real*4 t1,t2
      real*8 val1, val2
            
                   
      val1 = 1.0/0.69314718
      val2 = 1.0e-5
      lognb2 = int(dlog(dfloat(npt))*val1+val2)
      m = npt
      
      do nn=1,lognb2
         m = m/2
         k = npt - m
         do j=1,k
            i = j
3           continue
            l = i + m
            if(x1(l).le.x1(i)) then
               t1 = x1(i)	
	       t2 = x2(i)      
	       x1(i)=x1(l)
	       x2(i)=x2(l)	       
	       x1(l)=t1
	       x2(l)=t2
	       if(x1(i).eq.x1(l))then
	       if(x2(i).gt.x2(l))then
	          t1=x2(i)
		  x2(i)=x2(l)
		  x2(l)=t1
	       endif
	       endif
               i = i - m
               if(i.ge.1)goto 3
            endif
	    
	    
         enddo
      enddo
            
      return      
      end subroutine
     

