

C------------------------------------------------------ cubic spline
      subroutine spline(x,y,n,yp1,ypn,y2) 
      integer n,NMAX 
      real*4 yp1,ypn,x(n),y(n),y2(n) 
      parameter (NMAX=1000000) 
      integer i,k 
      real*4 p,qn,sig,un,uu(NMAX)
      
      if (yp1.gt..99e30) then 
        y2(1)=0.
        uu(1)=0.
      else
        y2(1)=-0.5
        uu(1)=(3./(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)    
      endif
              
      do  i=2,n-1
       sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
       p=sig*y2(i-1)+2.
       y2(i)=(sig-1.)/p
       uu(i)=(6.*((y(i+1)-y(i))/(x(i+1)-x(i))-(y(i)-y(i-1))
     *       /(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig*uu(i-1))/p 
      enddo
      
      
      if(ypn.gt..99e30)then
        qn=0.
        un=0.
      else
       qn=0.5
       un=(3./(x(n)-x(n-1)))*(ypn-(y(n)-y(n-1))/(x(n)-x(n-1)))  
      endif
      
      y2(n)=(un-qn*uu(n-1))/(qn*y2(n-1)+1.)
      do k=n-1,1,-1
       y2(k)=y2(k)*y2(k+1)+uu(k) 
      enddo
      return
      end

C------------------------------------------------------  spline interpolation
      subroutine splint(xa,ya,y2a,n,x,y)
      
      
      integer n
      real*4 x,y,xa(n),y2a(n),ya(n),a,b,h
      integer k,khi,klo
      
      
      klo=1
      khi=n
12    if (khi-klo.gt.1) then 
         k=(khi+klo)/2
         if(xa(k).gt.x)then
	   khi=k
	 else
	   klo=k
	 endif
      goto 12
      endif
      
      h=xa(khi)-xa(klo)
      a=(xa(khi)-x)/h
      b=(x-xa(klo))/h 
      y=a*ya(klo)+b*ya(khi)
      
      return 
      end 
