CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C       								       C
C       			   4DAO v 1.0				       C
C                           An interface for DAOSPEC                           C
C       								       C
C     Copyright (C) 2013  Alessio Mucciarelli				       C
C       								       C
C     This program is free software: you can redistribute it and/or modify     C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.				       C
C       								       C
C     This program is distributed in the hope that it will be useful,	       C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of	       C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	       C
C     GNU General Public License for more details.			       C
C       								       C
C     You should have received a copy of the GNU General Public License        C
C     along with this program.  If not, see <http://www.gnu.org/licenses/>.    C
C       								       C
C     For any questions please contact us: alessio.mucciarelli2@unibo.it       C
C       								       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      program xdao

      implicit none
      include 'xDeclare.f'
       
      
      write(*,*)'                     ########################'
      write(*,*)'                             4DAO 1.0'
      write(*,*)'                            (Nov 2013)'
      write(*,*)
       
       
       
      !--------- set here the name of your DAOSPEC executable file
      
      nexe='daospec'
      
      !--------- some default DAOSPEC parameters
      
      sm_d=5
      ve_d=3
      
      !---------
        
      open(1,file='4dao.list',status='unknown')       
      open(5,file='daospec.log',status='unknown') 
      open(7,file='4dao.param',status='unknown')
      
      
      write(5,'(A26)')'# CONV=1  (FWHM CONVERGED)'
      write(5,'(A32)')'# CONV=0  (TOO MANY ITERACTIONS)'
      write(5,'(A25)')'# CONV=-1 (INFINITE LOOP)'
      write(5,'(A33)')'# CONV=-2 (TOO HIGH/TOO LOW FWHM)'
      write(5,'(A37)')'# CONV=-3 (NEGATIVE/MISSING SPECTRUM)'
      write(5,'(A27)')'# CONV=-4 (FORMAT PROBLEMS)'
      write(5,'(A20)')'# CONV=-5 (NO LINES)'
      write(5,'(A1)')'#'

      write(5,'(A131)')'#	      STAR		   FWHM 	
     &RV        eRV     Nlin     RES(%)  CONV       WAVE1       WAVE2
     &        RE    WAVE_RE'
     
     
     
!------------------------------------------------------------------- INPUT PARAMETERS (4DAO.PARAM)     
       
      conter=-1
      
555   read(7,*,end=556)st,st2

      ik=0
      if(st(1:1).ne.'#')then
        
          if(st2(1:1).eq.'-')then
             ik=ik+1
          else
            do i=0,9
              write(jcar,'(I1)')i
              if(st2(1:1).eq.jcar)ik=ik+1
            enddo
          endif
          
          !---character keywords
          if(ik.eq.0)then
            if(st.eq.'output')wout=st2
            if(st.eq.'clean')clean=st2
            if(st.eq.'gala')gala=st2
          endif
          !---numerical keywords
          if(ik.ne.0)then
            backspace(7)
            read(7,*)st,val
            if(st.eq.'tol')tol=val
            if(st.eq.'nimax')nimax=int(val)
            if(st.eq.'fmax')fmax=val
            if(st.eq.'verbose')verbose=int(val)
            if(st.eq.'plot')plot=int(val)
            if(st.eq.'restart')restart=int(val)
            if(st.eq.'conter')conter=int(val)
          endif
          
      endif
      goto 555
556   continue    
       
       
       
!------------------------------------------------------------------- CHECK ABOUT INPUT PARAMETERS
       
       
      if(tol.le.0)tol=0.1
      if(restart.lt.0)restart=0
      if(restart.gt.30)restart=30
      if(wout.ne.'F'.and.wout.ne.'f'.and.
     &    wout.ne.'A'.and.wout.ne.'a')wout='A'
      if(verbose.lt.0.or.verbose.gt.2)verbose=2
      if(clean.ne.'N'.and.clean.ne.'n'.and.
     &    clean.ne.'Y'.and.clean.ne.'y')clean='y'
      
       
       
!------------------------------------------------------------------- READ THE SPECTRA LIST (4DAO.LIST)

100   read(1,*,end=101)spec,fwhm,ord,v1,v2,sc,fixed,list,
     & w1,w2,re_met,fmask
       
      nc=0
      
      !------------ original guess parameters
      spec0=spec
      fwhm0=fwhm
      v10=v1
      v20=v2
      fixed0=fixed
      re_met0=re_met
      
      !------------ mask option 
      status=access(fmask,' ')
      if(status.eq.0)mask='M'
      if(status.ne.0)mask='N'	    
      if(fixed.eq.1)mask='N'   !---if FWHM is fixed, the option is disabled
      
      mask0=mask
      
      !------------check about the RV boundaries
      if(v1.lt.-500)v1=-500
      if(v2.gt.500)v2=500
      if(v1.ge.v2)then
         v1=-500
         v2=500
      endif
      
      
      !------------check for some values       
      if(fwhm.le.0)then
        conv=-2
        if(verbose.eq.2)write(*,*)'WARNING: negative FWHM'
        write(5,91)spec(1:index(spec," ")-1),null,null,null,
     &       null,null,null,null,null,null
        goto 100 
      endif
      
      if(sc.ne.0.and.sc.ne.1)then
        if(verbose.eq.2)write(*,*)'invalid SC value. Now SC=1'
        sc=1
      endif    
       
      if(fixed.ne.0.and.fixed.ne.1)then
        if(verbose.eq.2)write(*,*)'invalid FI value. Now FI=1'
        fixed=1
      endif    
      
      if(fwhm.le.0)then
        conv=-2
        if(verbose.eq.2)
     &  write(*,*)'WARNING: negative FWHM. Skip the star'
        write(5,91)spec(1:index(spec," ")-1),null,null,null,
     &       null,null,null,null,null,null
        goto 100 
      endif
      
      if(ord.lt.-1)then
        if(verbose.eq.2)write(*,*)'invalid ORD value. Now ORD=1'
        ord=1	    
      endif
      
      
      if(ord.gt.90)then
        if(verbose.eq.2)write(*,*)'invalid ORD value. Now ORD=90'
        ord=90 
      endif
      
      
      if(plot.ne.0.and.plot.ne.1)plot=0
      
      !-----
      if(verbose.ne.0)
     &write(*,*)'------STAR      ',spec(1:len_trim(spec))
       

!------------------------------------------------------------------- 

99    continue

      niter=1
      conv=1
      fx=fixed
      flag=0
      fout=0
      
      if(nc.eq.1)write(*,*)'CONTINUUM +'
      if(nc.eq.2)write(*,*)'CONTINUUM -'
      
      
      !------------ set RE for the first iteration
      if(nc.eq.0)then
       if(re_met.ge.0.and.re_met.le.30)re=re_met
       if(re_met.lt.0.or.re_met.gt.30)re=restart
      endif	
      
      
      !------------ READ THE FITS FILE       
      call fits_s
      
      if(w1.lt.w1_orig)w1=w1_orig+pixel
      if(w2.gt.w2_orig)w2=w2_orig-pixel
      
      if(nc.eq.0)then
        lenf0=lenf
        spec3=spec2(1:lenf0)
      endif	
      
      out1=spec(1:lenf)//'.daospec'
      if(nc.eq.0)then
        out2=spec(1:lenf)//'.in'
        out0=out1
      endif	
      
       !------------ negative spectrum: exit!
      if(fout.eq.1)then
       conv=-3
       write(5,91)spec(1:index(spec," ")-1),null,null,null,
     &       null,null,conv,null,null,null,null
       fout=0
       goto 100 
      endif
      
      
!------------------------------------------------------------------- WRITE 'LABORATORY.DAT'

      open(10,file='laboratory.dat',status='unknown')
      open(11,file=list,status='unknown')
      
      nout=0
      
300   read(11,*,end=301)st
      
      if(st(1:1).ne.'#')then
        backspace(11)
        if(gala.eq.'Y'.or.gala.eq.'y')then
          read(11,*)wobs,code0,gf,ep,g1,g2,g3,bark 
          write(10,92)wobs,code0,gf,ep,g1,g2,g3,bark  
        else
          read(11,*)wobs,code0
          backspace(11)
          read(11,'(A)')st     
          it=1
302       continue
          if(st(it:it).eq.' ')then
           it=it+1
           goto 302
          endif   
          write(10,'(A)')st(it:len_trim(st))
        endif 
        if(wobs.ge.w1.and.wobs.le.w2)nout=nout+1   
      endif
     
      goto 300
301   continue
       
      close(11)
      close(10)
      
      
      !------------ no input lines in the wavelength range: exit!
      if(nout.eq.0)then
        conv=-5
        if(verbose.eq.2)write(*,*)'NO LINE IN THE WAVELENGTH RANGE'
        write(5,91)spec(1:index(spec," ")-1),null,null,null,
     &       null,null,null,null,null,null
        goto 100
      endif  
        	   
      io=1
      old_f(io)=fwhm
      zero=0


!------------------------------------------------------------------- 
       
200    continue
       
       
       if(verbose.eq.2)then
       
       if(niter.eq.1.and.zero.eq.0)
     & write(*,*)' FWHM       RE        RV1         RV          RV2'
       
       if(niter.eq.1.and.fx.eq.0)
     & write(*,'(F6.2,6x,I3,6x,F6.1,18x,F6.1,5x,A7)')
     & fwhm,nint(re),v1,v2,'(GUESS)'
       
       if(niter.ne.1.and.fx.eq.0.and.mask.ne.'M')
     & write(*,'(F6.2,6x,I3,3(6x,F6.1),5x,A7)')
     & fw2,nint(re),v1,vrad,v2
     
       if(niter.ne.1.and.fx.eq.0.and.mask.eq.'M')
     & write(*,'(F6.2,6x,I3,3(6x,F6.1),5x,A19)')
     & fw2,nint(re),v1,vrad,v2,'           (MASKED)'
     
       if(niter.ne.1.and.fx.eq.1)
     & write(*,'(F6.2,6x,I3,3(6x,F6.1),5x,A7)')
     & fw2,nint(re),v1,vrad,v2,'(FIXED)'
     
       if(niter.eq.1.and.fx.eq.1)
     & write(*,'(F6.2,6x,I3,6x,F6.1,18x,F6.1,5x,A7)')
     & fwhm,nint(re),v1,v2,'(FIXED)'
      
       endif
       
!------------------------------------------------------------------- WRITE 'DAOSPEC.OPT'
      

      open(6,file='daospec.opt',status='unknown')       
      
      write(6,'(A9)')'le = 4500'
      write(6,'(A9)')'ri = 6800'
      write(6,'(A5,1x,F6.1)')'mi = ',v1
      write(6,'(A5,1x,F6.1)')'ma = ',v2
      write(6,'(A5,1x,I2)')'ve = ',ve_d
      write(6,'(A6)')'WA = 0'
      write(6,'(A6)')'CR = 1'
      write(6,'(A5,1x,F6.2)')'FW = ',fwhm
      write(6,'(A5,1x,F9.2)')'SH = ',w1  
      write(6,'(A5,1x,F9.2)')'LO = ',w2   
      write(6,'(A5,1x,I1)')'SC = ',sc
      write(6,'(A5,1x,I1)')'FI = ',fx
      write(6,'(A5,1x,I3)')'ORD = ',int(ord)
      write(6,'(A5,1x,I2)')'SM = ',sm_d
      write(6,'(A5,1x,I2)')'RE = ',nint(re)
       
       
      !------------ check formats in DAOSPEC.OPT      
      rewind(6)
      
783   read(6,'(A)',end=784)linec
        linei=index(linec,'*')
	if(linei.ne.0)then
	 conv=-4
         if(verbose.eq.2)
     &   write(*,*)'WARNING: FORMAT ERRORS IN DAOSPEC.OPT'
         write(5,91)spec(1:index(spec," ")-1),null,null,null,
     &        null,null,null,null,null,null
        goto 100 
        endif
	goto 783
784   continue	

      close(6)
      
      
       
       
!------------------------------------------------------------------- DAOSPEC !!!!
       
      !------------ write the script to launch daospec       
      open(2,file='xdaospec.csh',status='unknown')
      write(2,*)nexe(1:index(nexe," ")-1),'<<EOF>log.daospec'
      write(2,*)
      write(2,*)spec(1:index(spec," ")-1)
      write(2,*)
      write(2,'(A3)')'EOF'
      close(2)
       
       
      call system('chmod a+x xdaospec.csh')
      call system('./xdaospec.csh')
       
	   
      !------------ read the R + C output spectra (only for nc=0, no continuum variation)
      if(nc.eq.0)call fits_rc
       
       
             
!------------------------------------------------------------------- READ THE OUTPUT FILE *****.DAOSPEC
       
       
      nhe=0
      open(3,file=out1,status='unknown')
      
      
      read(3,'(A50)')stc
      if(stc(19:28).eq.'**********'.or.stc(43:49).eq.'*******')then
        conv=-4
        goto 999      
      endif
      backspace(3)
      
      
708   read(3,*,end=709)
        nhe=nhe+1
	goto 708 
709     continue
      rewind(3)
      
      !------------ original number of total lines 
      
      if(nc.eq.0)nl0=nhe-2
       
       
      !------------ empty output file: exit
      if(nhe.lt.3)then
        conv=-4
        if(verbose.eq.2)write(*,*)'WARNING: empty ***.daospec file'
        write(5,91)spec(1:index(spec," ")-1),null,null,null,
     &        null,null,null,null,null,null
        goto 100 
      endif
       
      !------------ 
      read(3,'(A18,F10.4,A13,F8.3,A8,F8.3,1x)')
     &dmp,vrad,dmp1,disp,dmp2,fw2     
      read(3,'(A47,A6)')blabla,res_c
      read(res_c,*)res 
      rewind(3)
     
      io=io+1
      old_f(io)=fw2
       

      if(fixed.eq.1.and.(re_met.ge.0.and.re_met.le.30))then
        goto 140
      endif
      zero=zero+1
      if(fixed.eq.1.and.nc.ne.0)zero=2        


!------------------------------------------------------------------- RE 
      
      if(nc.eq.0)then 
       if(re_met.ge.0.and.re_met.lt.1000)goto 702
       call calre
      endif 
      
      if(fixed.eq.1.and.zero.eq.1)then
         !zero=0
	 niter=niter+1
        close(3)
        goto 200
      endif

702   if(fixed.eq.1.and.zero.gt.1.and.mask.ne.'M')goto 140



!------------------------------------------------------------------- MASKED SPECTRUM (if any)

      if(mask.eq.'M'.and.niter.eq.1)then
     	call xmask
     	spec='masked'
     	out1=spec(1:index(spec," ")-1)//'.daospec'
        niter=niter+1
     	fwhm=fw2
        goto 200
      endif

       
      if(fx.eq.0)then
       do ij=1,io-1
     	if(old_f(io).eq.old_f(ij))then
          if(verbose.eq.2)write(*,*)'INFINITE LOOP: EXIT'
          conv=-1
          goto 140	
        endif
       enddo
      endif
       
       
!------------------------------------------------------------------- CONVERGENCE CRITERIA
       
       !----not converged     
       if(abs(fw2-fwhm).gt.tol)then
       
	 if(nc.eq.2.and.abs(fw2-fwhm).gt.difw1)then
	   fwhm=fwhm_best+difw1
	   fw2=fwhm
	   fixed=1
   	   fx=1
	   niter=niter+1
	   close(3)
	   goto 200
	 endif
         
       
         fwhm=fw2
	 niter=niter+1
	 
	 
	 if(nc.eq.0)then
	  v1=vrad-5*disp
	  v2=vrad+5*disp
	 endif
	 !
	 if(niter.eq.nimax)then
	   !conv=0
	   if(verbose.eq.2)write(*,*)'TOO MANY ITERATIONS'
	   conv=0
	   goto 140
	 endif  
	 !
	 if(fwhm.gt.fmax)then
	   !conv=0
	   if(verbose.eq.2)write(*,*)'TOO HIGH FWHM'
	   conv=-2
	   goto 140
	 endif  
	 !
	 close(3)
	 goto 200	
	  
       endif
       
       
       !---- converged
       if(abs(fw2-fwhm).le.tol.and.flag.eq.0)then	 
	 if(nc.gt.0)spec=spec4
	 if(nc.eq.0)then
	   fwhm_best=fw2
	   v1_best=v1
	   v2_best=v2
	 endif  
         flag=1
	 fx=1
         fwhm=fw2 
	 niter=niter+1
	 close(3)
	 goto 200	 
       endif
       
       
       if(nc.eq.1)difw1=abs(fwhm-fwhm_best)
       if(verbose.eq.2)write(*,'(A14)')'FWHM CONVERGED'
140    rewind(3)
       
       
!------------------------------------------------------------------- CONTINUUM PLUS/MINUS
       close(3)
       if(nc.eq.0)open(3,file=out0,status='unknown')
       if(nc.gt.0)open(3,file=out1,status='unknown')
       nl=0
130    read(3,*,end=131)
       nl=nl+1
       goto 130       
131    continue
       
       
       if(nc.eq.0)call fits_f
       nc=nc+1
       
       rewind(3)
            
       if(nc.eq.1)then
         !write(*,*)'NC',nc,out0,out1
         inl=1
         read(3,*)
         read(3,'(A47,A6)')blabla,res_c
         read(res_c,*)res_0 
	 do i=1,nl-2
          read(3,'(A52)')blabla
	  if(blabla(50:52).ne.'   ')then
	   backspace(3)
	   read(3,*)w0,w,ew,erew,q,wobs
	   mysave1(inl)=wobs
	   mysave2(inl)=ew
	   mysave(inl,1)=wobs
	   mysave(inl,2)=ew	
	   inl=inl+1   
	  endif
	 enddo
	 inl=inl-1
	 close(3)
       endif
       

       if(nc.gt.1)then
         read(3,*)	  
         read(3,*)
	 do j=1,nl-2	
          read(3,'(A52)')blabla
	  if(blabla(50:52).ne.'   ')then
	   backspace(3)
	   read(3,*)w0,w,ew,erew,q,wobs
	   
	   do i=1,inl
	     if(wobs.eq.mysave1(i).and.nc.eq.2)mysave3(i)=ew
	     if(wobs.eq.mysave1(i).and.nc.eq.3)mysave4(i)=ew
	   enddo 
	  endif 
	 enddo         
	 close(3)
       endif
       
       
       
       !normalized PLUS/MINUS
       
       
       if(conter.eq.0.or.conter.eq.1)then
        if(nc.eq.1)call fits_pm
        if(nc.eq.1)spec=spec3(1:lenf0)//'_p.fits' 
        if(nc.eq.2)spec=spec3(1:lenf0)//'_m.fits' 
	if(nc.gt.0)spec4=spec
	if(conter.eq.0)fixed=0
	if(conter.eq.1)fixed=1
	
	if(fixed0.eq.1)fixed=1
	
	mask='N'	
	ord=-1
	if(fixed.eq.0)then
	 fwhm=fwhm_best
	 fw2=fwhm_best
	endif
	
        if(nc.lt.3)goto 99
	mask=mask0
       endif
       
       
       
!-------------------------------------------------------------------  OUTPUT

    
      !----WRITE THE OUTPUT FILE *****.IN
      open(4,file=out2,status='unknown')
       
      open(3,file=out0,status='unknown')
      
      nl=0
240   read(3,*,end=241)
      nl=nl+1
      goto 240       
241   continue
      nl0=nl-2
      
      rewind(3)
      
      
      
      read(3,'(A18,F10.4,A13,F8.3,A8,F8.3,1x,A5)')
     &dmp,vrad,dmp1,disp,dmp2,fw2,nline_c
      
      read(nline_c,*)nline 
      vr1=vrad-5*disp
      vr2=vrad+5*disp
     
      read(3,'(A47,A6)')blabla,res_c
      read(res_c,*)res 
      
      wave_xre=wave_xre/(vrad/speed+1)

      write(5,91)spec0(1:index(spec0," ")-1),fw2,vrad,disp,nline,
     &res,conv,w1,w2,nint(re),wave_xre
       conv=1
       nl2=1
       do i=1,nl0 
         read(3,'(A52)')blabla
	 if(blabla(50:52).ne.'   ')then
	   backspace(3)
	   if(gala.eq.'Y'.or.gala.eq.'y')then
             read(3,*)w0,w,ew,erew,q,wobs,code0,gf,ep,g1,g2,g3,bark
	     if(conter.eq.0.or.conter.eq.1)then
	      do j=1,inl
	       if(wobs.eq.mysave1(j))
     &	       write(4,96)wobs,ew,erew,code0,gf,ep,g1,g2,g3,bark,q,
     &                  mysave3(j),mysave4(j)
               enddo	     
	     else
	       write(4,90)wobs,ew,erew,code0,gf,ep,g1,g2,g3,bark,q
	     endif  
	   else
	     read(3,*)w0,w,ew,erew,q,wobs
	     backspace(3)
	     read(3,'(A)')st
	     if(conter.eq.0.or.conter.eq.1)then
	      do j=1,inl
	       if(wobs.eq.mysave1(j))
     &	       write(4,97)wobs,ew,erew,q,
     &                    st(53:len_trim(st)),mysave3(j),mysave4(j)
               enddo	     	      
	     else
	      write(4,94)wobs,ew,erew,q,st(53:len_trim(st))
	     endif
	   endif  
	   s_wave(nl2)=wobs
	   s_vrad(nl2)=(w0-wobs)/wobs*speed
	   s_ew(nl2)=ew
	   s_q(nl2)=q
	   s_per(nl2)=erew/ew*100
	   s_elem(nl2)=code0
	   
	   nl2=nl2+1
	 endif
        enddo
       
       nl2=nl2-1
       close(3)
       close(4)
       
       call xplot
       
       
       exte1='gs -dNOPAUSE -sDEVICE=pdfwrite -sOutputFile='
       exte2='_4DAO.pdf _tmp_*.ps  -c quit'
       exte3='ps2pdf -dEPSCrop '
       call system(exte1//outp2(1:(index(outp2," ")-1))//exte2//'>tmp0')
!      call system(exte3//outp2(1:(index(outp2," ")-1))//'.ps '//
!     &                    outp2(1:(index(outp2," ")-1))//'.pdf ')
       call system('rm _tmp_plot_*.ps _tmp_vr.ps _tmp_zpar.ps tmp0')
     
       if(conter.eq.0.or.conter.eq.1)call system('rm _tmp_pm.ps') 
       
       
      if(mask.eq.'M'.and.(clean.eq.'y'.or.clean.eq.'Y'))
     &call system('rm masked.daospec masked*.fits')
       
       
      if(clean.eq.'y'.or.clean.eq.'Y')
     &call system('rm log.daospec daospec.opt laboratory.dat 
     &             xdaospec.csh')        
      goto 100

999   continue  
      fw2=0
      vrad=9999
      disp=0
      nline=0
      res=0
      close(3)
      write(5,91)spec0(1:index(spec0," ")-1),fw2,vrad,disp,nline,
     &res,conv,w1,w2,nint(re),wave_xre
     
      conv=1
      nl2=1
      goto 100
      
101    continue

       close(1)
       close(2)
       close(5)
       close(7)
       
90     format(F9.3,3x,F8.3,3x,F8.3,3x,F5.2,5(3x,F7.3),3x,F5.3,3x,F6.3)   
91     format(A30,3x,F7.3,3x,F9.3,3x,F7.3,3x,I4,3x,F7.3,3x,I2,7x,
     &2(F9.3,3x),I4,3x,F9.3)
92     format(F8.3,3x,F5.2,5(3x,F7.3),3x,F5.3)
93     format(F8.3,3x,F5.2,A100)
94     format(F9.3,3x,F8.3,3x,F8.3,3x,F9.3,3x,A)
95     format(F8.3,3x,A)
96     format(F9.3,3x,F8.3,3x,F8.3,3x,F5.2,5(3x,F7.3),3x,F5.3,3x,
     &F6.3,2(3x,F9.3))  
!97     format(F9.3,3x,F8.3,3x,F8.3,3x,F9.3,2(3x,F9.3),A)
97     format(F9.3,3x,F8.3,3x,F8.3,3x,F9.3,A,2(3x,F9.3))
       end
       
  
