CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of 4DAO					               C
C                                                                              C
C     4DAO is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     4DAO is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with 4DAO. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine fits_f
      
C-----The subroutine computes the 'fitted' spectrum and creates the output 
C-----spectrum ****_NZV (fits or dat).
      
      implicit none      
      include 'xDeclare.f'

      
C----- define the 'fitted' spectrum defined as F = (O/C) - R
      
      j=1
      maxi=0
     
      do i=1,dobsr
       if(ord.ne.-1)then
       
        if(i_cont(i).gt.0)then
	norma(j)=iox_0(i)/i_cont_0(i)
        fitted(j)=iox_0(i)/i_cont_0(i)-i_res_0(i)
	contin(j)=i_cont_0(i)
	wsampl(j)=wox_0(i)
	wfitted(j)=wox_0(i)-(wox_0(i)*vrad/speed)

	if(i_cont_0(i).gt.maxi)maxi=i_cont_0(i)
	
	j=j+1
	endif
	
       else
         norma(j)=iox_0(i)
	 fitted(j)=iox_0(i)-i_res_0(i)
	 contin(j)=1
	 wsampl(j)=wox_0(i)
	 wfitted(j)=wox_0(i)-(wox_0(i)*vrad/speed)
	 maxi=1.
	 j=j+1
       endif	
      enddo
      dobs2=j-1


200   continue    


C----- define the normalized, rest-frame observed spectrum

      if(wout.eq.'A'.or.wout.eq.'a')then       
        outsp=spec0(1:lenf0)//'_NZV.dat'  
        open(20,file=outsp,status='unknown')
        do i=1,dobs2
          write(20,'(F13.7,3x,F11.7)')wfitted(i),norma(i)	 
	enddo
        close(20)
      endif
      
      
      if(wout.eq.'F'.or.wout.eq.'f')then
        outsp=spec0(1:lenf0)//'_NZV.fits' 
        
	status=access(outsp,' ')
        if(status.eq.0)call system('rm '//outsp)
	
        status=0
        simple=.true.
	extend=.true.
	crval1=wfitted(1)
	crpix1=1.
	dcflag=0.
	cdelt1=(wfitted(dobs2)-wfitted(1))/(dobs2-1)
	
	
	do i=1,dobs2
	  array(i)=norma(i)
	enddo
	
        call ftinit(1,outsp,1,status)
        call ftphpr(1,simple,-32,1,dobs2,0,1,extend,status)  
        call ftpkyg(1,'CRVAL1',crval1,11,' ',status)
        call ftpkyg(1,'CRPIX1',crpix1,0,' ',status)
        call ftpkyg(1,'CDELT1',cdelt1,15,' ',status)
        call ftpkyg(1,'CD1_1',cdelt1,15,' ',status)
        call ftpkyg(1,'DC-FLAG',dcflag,0,' ',status)
        call ftppnd(1,1,1,dobs2,array,-200.,status)
        call ftclos(1,status)
        call ftfiou(1,status)
      endif
      
            
      end 
