CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of 4DAO					               C
C                                                                              C
C     4DAO is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     4DAO is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with 4DAO. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine fits_rc

C The subroutine reads the residual and continuum fits files
      
      implicit none      
      include 'xDeclare.f'

      
C----- read the 'residuals' spectrum ***R.fits 
      
      resid=spec2(1:lenf)//'R.fits'    
      status=0
      r=0
      

      !-------------- open the fits
      call ftopen(1,resid,r,size,status)
      if(status.ne.0)then
       if(verbose.eq.2)write(*,*)'The spectrum does not exist'
       fout=1
       call ftclos(1,status)
       goto 200
      endif 
      
      !-------------- read some keywords in the header
      call ftgkyd(1,'CRVAL1',crval_r,comm,status)
      call ftgkyd(1,'CDELT1',cdelt_r,comm,status)
      call ftgkyd(1,'NAXIS1',naxis_r,comm,status) 
      call ftgkyd(1,'CRPIX1',crpix_r,comm,status)
           
      dobsr = int(naxis_r)
      
      
      !-------------- read the 1-D spectrum
      call ftgpve(1,1,1,dobsr,-999,i_res,anynull,status)
      call ftclos(1,status)
      
      if(nc.eq.0)then
        do i=1,dobsr
	  i_res_0(i)=i_res(i)
	enddo
      endif
      
      
      if(nc.eq.0)call xresid
      
      if(ord.eq.-1.and.nc.ne.0)goto 200
      
      
C----- read the 'continuum' spectrum ***C.fits      

      cont=spec2(1:lenf)//'C.fits'      
      status=0
      r=0

      
      !-------------- open the fits
      call ftopen(1,cont,r,size,status)
      if(status.ne.0)then
       if(verbose.eq.2)write(*,*)'The spectrum does not exist'
       fout=1
       call ftclos(1,status)
       goto 200
      endif 
      
      !-------------- read some keywords in the header
      call ftgkyd(1,'CRVAL1',crval_c,comm,status)
      call ftgkyd(1,'CDELT1',cdelt_c,comm,status)
      call ftgkyd(1,'NAXIS1',naxis_c,comm,status)
      call ftgkyd(1,'CRPIX1',crpix_c,comm,status)
      
      dobsc = int(naxis_c)
      
      !-------------- read the 1-D spectrum
      call ftgpve(1,1,1,dobsc,-999,i_cont,anynull,status)
      
      if(nc.eq.0)then
        do i=1,dobsc
	  i_cont_0(i)=i_cont(i)
	enddo
      endif
      
      call ftclos(1,status)
      
      
200   continue   
      
      end 
