CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of 4DAO					               C
C                                                                              C
C     4DAO is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     4DAO is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with 4DAO. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine fits_s

C----- The subroutine reads the input fits file

      
      implicit none     
      include 'xDeclare.f'
      
      
      !-------------- check about the extension     
      lenf=len_trim(spec)  
      endf=spec((lenf-4):lenf)    
      
      if(endf.eq.'.fits')then
         spec2=spec(1:(lenf-5))
	 lenf=lenf-5
	 if(nc.eq.0)outp2=spec2
      endif
      
        
      if(endf.ne.'.fits')then
         spec=spec(1:lenf)//'.fits'
	 spec2=spec
	 if(nc.eq.0)outp2=spec(1:lenf)
      endif
      
     
      status=0
      r=0

      !-------------- open the fits
      call ftopen(1,spec,r,size,status)
      
      if(status.ne.0)then
       if(verbose.eq.2)write(*,*)'The spectrum does not exist'
       fout=1
       goto 200
      endif 
      
      !-------------- read some keywords in the header
      call ftgkyd(1,'CRVAL1',crval,comm,status)
      call ftgkyd(1,'CDELT1',cdelt,comm,status)
      call ftgkyd(1,'NAXIS1',naxis,comm,status)
      call ftgkyd(1,'CRPIX1',crpix,comm,status)
      
      
      dobs = int(naxis)
      pixel=cdelt
      
      
      !-------------- read the 1-D spectrum
      call ftgpve(1,1,1,dobs,-999,iox,anynull,status)
      
      do i=1,dobs
        wox(i)=crval+(i-crpix)*cdelt
        wox2(i)=wox(i)
	if(nc.eq.0)then
	  iox_0(i)=iox(i)
	  wox_0(i)=wox2(i)
	endif
      enddo
      
      
      w1_orig=wox(1)
      w2_orig=wox(dobs)
      
      if(w1.lt.w1_orig)w1=0
      if(w2.gt.w2_orig)w2=0
      

      
      !-------------- median value of the spectrum
      
      do i=1,dobs
        tmp0(i)=iox(i)
      enddo
      
      call calsig2(tmp0,dobs,md_s,sg_s)
     
      if(md_s.le.0)then
       fout=1
       if(verbose.eq.2)write(*,*)'WARNING: negative spectrum!'
       goto 200
      endif 
      
      
      
      !-------------- vectors without 0
      
      dnoz=1
      do i=1,dobs
        if(iox(i).gt.0)then
	  wtmp(dnoz)=wox(i)
	  itmp(dnoz)=iox(i)
	  dnoz=dnoz+1
	endif
      enddo
      dnoz=dnoz-1
      
      nbn=30
      nsigma=10
      
      !---median - first piece
      
      if(w1.eq.0)then
     	nmed=1
     	do i=1,int(dnoz/nbn)
     	  itmp2(nmed)=itmp(i)
     	  nmed=nmed+1
     	enddo
     	nmed=nmed-1	 
     	call calsig(itmp2,nmed,val1,val3)
     	call calsig2(itmp2,nmed,val1,val2)
     	
     	
     	
     	!----W1   
     	w1=wtmp(1)
     	do i=1,(dnoz/nbn)
     	  if(itmp(i).lt.(0.1*val1))w1=wtmp(i+1)
     	enddo
	
	w1=w1+pixel
      endif
      
      
      !---median - second piece
      if(w2.eq.0)then
        nmed=1
        do i=(dnoz-dnoz/nbn),dnoz
          itmp2(nmed)=itmp(i)
          nmed=nmed+1
        enddo
        nmed=nmed-1	 
        call calsig(itmp2,nmed,val1,val3)
        call calsig2(itmp2,nmed,val1,val2)
              
        !----W2       
        w2=wtmp(int(dnoz-dnoz/nbn))
        do i=int(dnoz-dnoz/nbn),dnoz
          if(itmp(i).gt.(0.1*val1).and.
     &       itmp(i).lt.(1.2*val1))w2=wtmp(i)
        enddo
       
        w2=w2-pixel
      endif

      
      
      
      
      
200   continue           


      !-------------- close the fits
      call ftclos(1,status)
      
      
      end
