CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of 4DAO					               C
C                                                                              C
C     4DAO is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     4DAO is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with 4DAO. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine xmask
      
      implicit none
      include 'xDeclare.f'
            
	    
      call when(idum)
      
      outsp='masked.fits' 
      status=access(outsp,' ')
      if(status.eq.0)call system('rm '//outsp)
      
      
      open(22,file=fmask,status='unknown')
      
      ik=1
100   read(22,*,end=101)mask1(ik),mask2(ik) !,restf
      ik=ik+1
      goto 100
101   continue
      ik=ik-1
      nmask=ik
      close(22)
      
      
      status=0
      simple=.true.
      extend=.true.
      crval1=wox(1)
      crpix1=1.
      cdelt1=(wox(dobs)-wox(1))/(dobs-1)
      
      crval1=crval
      crpix1=crpix  !int(crpix)
      cdelt1=cdelt
      
      
      
      do i=1,dobs
        array(i)=iox(i)
       do j=1,ik
         if(wox2(i).gt.mask1(j).and.wox2(i).lt.mask2(j))then
	   if(ord.ne.-1)array(i)=i_cont(i)*(1+xgdev(idum)/(1/(res/100)))
	   !if(ord.ne.-1)array(i)=i_cont(i)*(1+xgdev(idum)/(1/myres(i)))
	   !if(ord.eq.-1)array(i)=1.*(1+xgdev(idum)/(1/(res/100)))
	   if(ord.eq.-1)array(i)=i_cont(i)*(1+xgdev(idum)/(1/myres(i)))
         endif
       enddo
      enddo
      
      
      
	
      call ftinit(1,outsp,1,status)
      call ftphpr(1,simple,-32,1,dobs,0,1,extend,status)  
      call ftpkyg(1,'CRVAL1',crval1,15,' ',status)
      call ftpkyg(1,'CRPIX1',crpix1,15,' ',status)
      call ftpkyg(1,'CDELT1',cdelt1,15,' ',status)
      call ftpkyg(1,'CD1_1',cdelt1,15,' ',status)
      call ftppnd(1,1,1,dobs,array,-200.,status)
      call ftclos(1,status)
      call ftfiou(1,status)
            
      
      
      end subroutine
      
C------------------------------------------------------------------  Guassian noise

      function xgdev(idum)
      
      implicit none
      
      integer idum,ival
      real*4 xgdev,val1,val2,valq,val0,ab
      real*4 xrandom
      
      
      
      ival=0
      if(ival.eq.0)then
500     val1=2*xrandom(idum)-1.
	val2=2*xrandom(idum)-1.
	valq=(val1**2)+(val2**2)
	if(valq.eq.0.or.valq.ge.1)goto 500
	val0=sqrt(-2.*log10(valq)/valq)
	ab=val1*val0
	xgdev=val2*val0
	ival=1
      else
        xgdev=ab
	ival=0
      endif
      
      return
      end
      
C------------------------------------------------------------------  
      
  
      function xrandom(idum)
      
      implicit none
      
      integer idum,ya,ym,yq,yr,ntab,yd
      real*4 xrandom,yam,yeps,valmax
      parameter(ya=16807)
      parameter(ym=2147483647)
      parameter(yam=1./ym)
      parameter(yq=127773)
      parameter(yr=2836)
      parameter(ntab=32)
      parameter(yd=1+(ym-1)/ntab)
      parameter(yeps=1.2e-7)
      parameter(valmax=1.-yeps)      
      integer j,k,yv(ntab),iy
      
      save yv,iy
      data yv /ntab*0/, iy /0/
      
      if (idum.le.0.or.iy.eq.0) then
        idum=max(-idum,1)
        do j=ntab+8,1,-1
          k=idum/yq
          idum=ya*(idum-k*yq)-yr*k
          if (idum.lt.0) idum=idum+ym
          if (j.le.ntab) yv(j)=idum
        enddo
        iy=yv(1)
      endif
      
      k=idum/yq
      idum=ya*(idum-k*yq)-yr*k
      if (idum.lt.0) idum=idum+ym
      j=1+iy/yd
      iy=yv(j)
      yv(j)=idum
      xrandom=min(yam*iy,valmax)
      return
      end
      
C------------------------------------------------------- compute the initial random seed
      subroutine when(seed)
      implicit none
      integer*4 now(3)
      integer seed
      call itime(now)
      seed=now(1)*now(2)*now(3)
      seed=seed**2
      seed=-seed       
      end
  
