CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C									       C
C     This file is part of 4DAO					               C
C                                                                              C
C     4DAO is free software: you can redistribute it and/or modify             C
C     it under the terms of the GNU General Public License as published by     C
C     the Free Software Foundation, either version 3 of the License, or        C
C     (at your option) any later version.                                      C
C                                                                              C
C     4DAO is distributed in the hope that it will be useful,                  C
C     but WITHOUT ANY WARRANTY; without even the implied warranty of           C
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            C
C     GNU General Public License for more details.                             C
C    	                                                                       C
C     You should have received a copy of the GNU General Public License	       C
C     along with 4DAO. If not, see <http://www.gnu.org/licenses/>.             C
C									       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine xplot
             
      implicit none      
      include 'xDeclare.f'
      
      
      status=access('_tmp_pm.ps',' ')
      if(status.eq.0)call system('rm _tmp_pm.ps')
      
      !----wavelength limits
      wmini=100000
      wmaxi=-1
      do i=1,nl2
         if(s_wave(i).lt.wmini)wmini=s_wave(i)
         if(s_wave(i).gt.wmaxi)wmaxi=s_wave(i)
      enddo
      wmini=wmini-(wmaxi-wmini)/10
      wmaxi=wmaxi+(wmaxi-wmini)/10
      
      !----EW limits
      ewmini=100000
      ewmaxi=-1
      do i=1,nl2
         if(s_ew(i).lt.ewmini)ewmini=s_ew(i)
         if(s_ew(i).gt.ewmaxi)ewmaxi=s_ew(i)
      enddo
      ewmini=ewmini-(ewmaxi-ewmini)/10
      ewmaxi=ewmaxi+(ewmaxi-ewmini)/10
      
      !---error limit
      ermax=-1
      do i=1,nl2
        if(s_per(i).gt.ermax)ermax=s_per(i)
      enddo
      ermax=ermax+0.1*ermax
      
      
      !---Q parameter limit
      qmax=-1
      do i=1,nl2
        if(s_q(i).gt.qmax)qmax=s_q(i)
      enddo
      qmax=qmax+0.1*qmax
      
      
      open(31,file='laboratory.dat',status='unknown')
      
      nlb=1
90    read(31,*,end=91)linex0,code0
      if(linex0.ge.(w1-w1*vrad/speed).and.
     &   linex0.le.(w2-w2*vrad/speed))then
        linex(nlb)=linex0
	code(nlb)=code0
        nlb=nlb+1
      endif	
      goto 90
91    continue

      rewind(31)      
      
      nlb=nlb-1
      
      !---- sort for wavelength
      if(plot.eq.0)call sort2(nlb,linex,code)
      !----sort for element
      if(plot.eq.1)call sort2(nlb,code,linex)
      
 
      open(30,file=out2,status='unknown')
      flag2=1
      flag3=1
      flag4=1
      flag6=1
      flag7=1
      



      do ij=1,nlb
       flag5=0
       
       do i=1,nl2
        if(s_wave(i).eq.linex(ij))then
          q0=s_q(i)
	  e0=s_per(i)
	  elem0=s_elem(i)
	  ew0=s_ew(i)
	  rv0=s_vrad(i)
          flag5=1
	else	
          elem0=code(ij)	  	
	endif       
       enddo   
         
           
	   
       !---x-range +-6FWHM
     	    
       linex1=linex(ij)-6*fw2*pixel
       linex2=linex(ij)+6*fw2*pixel
       
       mini=1e19
       maxi2=0
       do i=1,dobs2
     	if(wfitted(i).gt.linex1.and.wfitted(i).lt.linex2)then
     	  if(norma(i).lt.mini)mini=norma(i)
     	  if(norma(i).gt.maxi2)maxi2=norma(i)
     	endif
       enddo
      
       pos1=mini-mini*0.1
       pos2=mini-mini*0.15
       if(mini.gt.0)mini=mini-mini*0.2
       if(mini.lt.0)mini=0
       if(maxi2.le.1.5)maxi2=maxi2+maxi2*0.2
       if(maxi2.gt.1.5)maxi2=1.5
       arr1=maxi2-maxi2*0.05
       arr2=maxi2-maxi2*0.15
      
       vmini=1000
       vmaxi=-1000
       do i=1,nl2
        if(s_vrad(i).lt.vmini)vmini=s_vrad(i)
        if(s_vrad(i).gt.vmaxi)vmaxi=s_vrad(i)
       enddo
       vmini=vmini-4*disp
       vmaxi=vmaxi+4*disp
      
   
      
       if(flag2.eq.1)then
     	
     	if(flag7.ge.10)then
     	  flag7=1
	  !flag3=flag3+1
     	  if(flag3.ge.10)then
	    flag3=1
	    flag6=flag6+1
	  endif 
     	endif
       
     	!write(nps2,'(I1)')flag3
     	if(flag6.lt.10)write(nps3,'(I1)')flag6
     	if(flag6.ge.10.and.flag6.lt.100)write(nps3,'(I2)')flag6
     	if(flag6.ge.100)write(nps3,'(I3)')flag6
       
     	if(flag3.lt.10)write(nps2,'(I1)')flag3
     	if(flag3.ge.10.and.flag3.lt.100)write(nps2,'(I2)')flag3
     	if(flag3.ge.100)write(nps2,'(I3)')flag3
     	
     	if(flag7.lt.10)write(nps4,'(I1)')flag7
     	if(flag7.ge.10.and.flag7.lt.100)write(nps4,'(I2)')flag7
     	if(flag7.ge.100)write(nps4,'(I3)')flag7
	
	
     	outps='_tmp_plot_'//nps3(1:index(nps3," ")-1)//'_'//
     &nps2(1:index(nps2," ")-1)//'_'//nps4
     	outps2=outps(1:index(outps," ")-1)//'.ps'
     	call sm_device_('postencap '//outps2)
     	call sm_graphics_
	
       endif 
       
       
       call sm_ctype_('black')      
       call sm_expand_(0.8)
       call sm_lweight_(4.0)
       
       if(flag2.eq.1)then
        call sm_location_(3500,30000,3500,30000)
        call sm_xlabel_('Wavelength (A)')
        call sm_ylabel_('Normalized Flux')
       endif
       
       if(flag2.eq.1)call sm_location_(4000,12000,23000,31000)
       if(flag2.eq.2)call sm_location_(13250,21250,23000,31000)
       if(flag2.eq.3)call sm_location_(22500,30500,23000,31000)
       if(flag2.eq.4)call sm_location_(4000,12000,14000,22000)
       if(flag2.eq.5)call sm_location_(13250,21250,14000,22000)
       if(flag2.eq.6)call sm_location_(22500,30500,14000,22000)
       if(flag2.eq.7)call sm_location_(4000,12000,5000,13000)
       if(flag2.eq.8)call sm_location_(13250,21250,5000,13000)
       if(flag2.eq.9)call sm_location_(22500,30500,5000,13000)       
      
      
       xelem=elemx(nint(elem0))
       if((elem0-nint(elem0)).eq.0)xion=' I'
       if((elem0-nint(elem0)).ne.0)xion=' II'
       
       write(mylab1,'(F8.3,12x,A2,A)')linex(ij),xelem,xion
       write(mylab2,'(A6,I3,A1,7x,A2,F5.2)')
     &'errEW=',int(e0),'%','Q=',q0
       write(mylab3, '(A3,F6.2,5x,A3,F7.2)')
     &'EW=',ew0,'RV=',rv0
       
       call sm_limits_(linex1,linex2,mini,maxi2)  
       call sm_expand_(0.5)
       call sm_box_(0,2,0,0)   
       call sm_expand_(0.8)
       call sm_connect_(wfitted,norma,dobs2)
       if(flag5.eq.0)call sm_ctype_('blue')
       if(flag5.eq.1)call sm_ctype_('red')
       call sm_connect_(wfitted,fitted,dobs2)
          
       call sm_relocate_(linex1 + 0.05*(linex2-linex1),
     &(maxi2 - 0.14*(maxi2-mini)))
       call sm_label_(mylab1)
       
       
       if(flag5.eq.1)then
         call sm_expand_(0.7)
	 
         call sm_relocate_(linex1 + 0.05*(linex2-linex1),
     &   (mini + 0.08*(maxi2-mini)))
         call sm_label_(mylab2)
	 
         call sm_relocate_(linex1 + 0.05*(linex2-linex1),
     &   (mini + 0.16*(maxi2-mini)))
         call sm_label_(mylab3)
	 
         call sm_expand_(0.8)
	 
       endif
       
       
       call sm_ctype_('blue')
       call sm_relocate_(linex(ij),arr1)
       call sm_draw_(linex(ij),arr2)	
       call sm_ctype_('black')	
       
       if(flag2.eq.9)then
        call sm_alpha_     
        call sm_device_('x11')
        flag2=1
        if(flag7.eq.9)flag3=flag3+1
        flag7=flag7+1
       else
        flag2=flag2+1
       endif
      
      
       if(flag4.eq.nlb)then
        goto 81
       else
        flag4=flag4+1
       endif 
      
       rewind(30) 
        

81     continue
      enddo   

      close(30)
      close(31)
      
      
C--------------------------------------------- observed spectrum + DAOSPEC continuum
      
      
      call sm_ctype_('black')	   
      call sm_device_('postlandfile _tmp_plot_0.ps')
      call sm_graphics_
      call sm_expand_(0.8)
      call sm_lweight_(3.0)
      
      call sm_location_(3500,30000,3500,30000)
      call sm_limits_(w1_orig,w2_orig,0.,(maxi+0.5*maxi))
      call sm_xlabel_('Wavelength (A)')
      call sm_ylabel_('Flux')
      
      if(mask.eq.'M')then
       call sm_ctype_('yellow')
       do i=1,nmask
        xvet(1)=mask1(i)
	xvet(2)=mask2(i)
	xvet(3)=mask2(i)
	xvet(4)=mask1(i)
	xvet(5)=mask1(i)
	
        yvet(1)=-10
        yvet(2)=-10
        yvet(3)=1e10
        yvet(4)=10e10
        yvet(5)=-10	
        call sm_shade_(10,xvet,yvet,5,1) 
       enddo
      call sm_ctype_('black')	
      endif
      
      
      call sm_box_(1,2,0,0) 
      call sm_connect_(wox_0,iox_0,dobs)
      call sm_ctype_('red')
      call sm_connect_(wsampl,contin,dobs2) 

      
      call sm_alpha_	   
      call sm_device_('x11')
      
      
      if(disp.eq.0)goto 400
      
C--------------------------------------------- individual RV vs wavelength
      
      call sm_ctype_('black')	   
      call sm_device_('postencap _tmp_vr.ps')
      call sm_graphics_
      call sm_expand_(0.8)
      call sm_lweight_(3.0)
      
      call sm_location_(3500,30000,18000,30000)
      call sm_limits_(wmini,wmaxi,vmini,vmaxi)
      call sm_box_(1,2,0,0) 
      call sm_expand_(1.3)
      call sm_xlabel_('Wavelength (A)')
      call sm_ylabel_('RV (km/s)')
      call sm_ptype_(303.,1)
      call sm_points_(s_wave,s_vrad,nl2)
      
     
      
      call sm_expand_(0.6)
      call sm_relocate_((wmaxi+0.01*(wmaxi-wmini)),vrad)
      call sm_label_('<RV>')
      call sm_relocate_((wmaxi+0.01*(wmaxi-wmini)),(vrad+disp))
      call sm_label_('+1sigma')
      call sm_relocate_((wmaxi+0.01*(wmaxi-wmini)),(vrad-disp))
      call sm_label_('-1sigma')
      call sm_relocate_((wmaxi+0.01*(wmaxi-wmini)),(vrad+2*disp))
      call sm_label_('+2sigma')
      call sm_relocate_((wmaxi+0.01*(wmaxi-wmini)),(vrad-2*disp))
      call sm_label_('-2sigma')
      call sm_relocate_((wmaxi+0.01*(wmaxi-wmini)),(vrad+3*disp))
      call sm_label_('+3sigma')
      call sm_relocate_((wmaxi+0.01*(wmaxi-wmini)),(vrad-3*disp))
      call sm_label_('-3sigma')
      call sm_expand_(0.8)
     
     
      call sm_relocate_(0.,vrad)
      call sm_draw_(1.e6,vrad)
      call sm_ltype_(2)
      call sm_relocate_(0.,(vrad-disp))
      call sm_draw_(1.e6,(vrad-disp))
      call sm_relocate_(0.,(vrad+disp))
      call sm_draw_(1.e6,(vrad+disp))
     
      call sm_relocate_(0.,(vrad-2*disp))
      call sm_draw_(1.e6,(vrad-2*disp))
      call sm_relocate_(0.,(vrad+2*disp))
      call sm_draw_(1.e6,(vrad+2*disp))
     
      call sm_relocate_(0.,(vrad-3*disp))
      call sm_draw_(1.e6,(vrad-3*disp))
      call sm_relocate_(0.,(vrad+3*disp))
      call sm_draw_(1.e6,(vrad+3*disp))
      call sm_ltype_(0)
      
      
      
C--------------------------------------------- individual RV vs EW
      
      
      call sm_expand_(0.8)
      call sm_lweight_(3.0)
      call sm_location_(3500,30000,3500,15500)      
      call sm_limits_(ewmini,ewmaxi,vmini,vmaxi)
      call sm_box_(1,2,0,0) 
      call sm_expand_(1.3)
      call sm_xlabel_('EW (mA)')
      call sm_ylabel_('RV (km/s)')
      call sm_ptype_(303.,1)
      call sm_points_(s_ew,s_vrad,nl2)
    
      
      call sm_expand_(0.6)
      call sm_relocate_((ewmaxi+0.01*(ewmaxi-ewmini)),vrad)
      call sm_label_('<RV>')
      call sm_relocate_((ewmaxi+0.01*(ewmaxi-ewmini)),(vrad+disp))
      call sm_label_('+1sigma')
      call sm_relocate_((ewmaxi+0.01*(ewmaxi-ewmini)),(vrad-disp))
      call sm_label_('-1sigma')
      call sm_relocate_((ewmaxi+0.01*(ewmaxi-ewmini)),(vrad+2*disp))
      call sm_label_('+2sigma')
      call sm_relocate_((ewmaxi+0.01*(ewmaxi-ewmini)),(vrad-2*disp))
      call sm_label_('-2sigma')
      call sm_relocate_((ewmaxi+0.01*(ewmaxi-ewmini)),(vrad+3*disp))
      call sm_label_('+3sigma')
      call sm_relocate_((ewmaxi+0.01*(ewmaxi-ewmini)),(vrad-3*disp))
      call sm_label_('-3sigma')
      call sm_expand_(0.8)
      
      call sm_relocate_(-10.,vrad)
      call sm_draw_(1.e6,vrad)
      call sm_ltype_(2)
      call sm_relocate_(-10.,(vrad-disp))
      call sm_draw_(1.e6,(vrad-disp))
      call sm_relocate_(-10.,(vrad+disp))
      call sm_draw_(1.e6,(vrad+disp))
      
      call sm_relocate_(-10.,(vrad+2*disp))
      call sm_draw_(1.e6,(vrad+2*disp))
      call sm_relocate_(-10.,(vrad-2*disp))
      call sm_draw_(1.e6,(vrad-2*disp))
      
      call sm_relocate_(-10.,(vrad-3*disp))
      call sm_draw_(1.e6,(vrad-3*disp))
      call sm_relocate_(-10.,(vrad+3*disp))
      call sm_draw_(1.e6,(vrad+3*disp))
      call sm_ltype_(0)
        
      
      call sm_alpha_	   
      call sm_device_('x11')
        

      
C--------------------------------------------- 1 sigma uncertainty + Q parameter


   
      call sm_ctype_('black')	   
      call sm_device_('postencap _tmp_zpar.ps')
      call sm_graphics_
      call sm_expand_(0.8)
      call sm_lweight_(3.0)
      
      call sm_location_(4000,17000,19000,31000)
      call sm_limits_(ewmini,ewmaxi,0.,ermax)
      call sm_box_(1,2,0,0) 
      call sm_ptype_(303.,1)
      call sm_points_(s_ew,s_per,nl2)
      call sm_xlabel_('EW (mA)')
      call sm_ylabel_('error EW(%)')
      
      call sm_location_(17000,30000,19000,31000)
      call sm_limits_(wmini,wmaxi,0.,ermax)
      call sm_box_(1,0,0,0) 
      call sm_ptype_(303.,1)
      call sm_points_(s_wave,s_per,nl2)
      call sm_xlabel_('Wavelength (A)')
      
      call sm_location_(4000,17000,4000,16000)
      call sm_limits_(ewmini,ewmaxi,0.,qmax)
      call sm_box_(1,2,0,0) 
      call sm_ptype_(303.,1)
      call sm_points_(s_ew,s_q,nl2)
      call sm_xlabel_('EW (mA)')
      call sm_ylabel_('Q parameter')
      
      call sm_location_(17000,30000,4000,16000)
      call sm_limits_(wmini,wmaxi,0.,qmax)
      call sm_box_(1,0,0,0) 
      call sm_ptype_(303.,1)
      call sm_points_(s_wave,s_q,nl2)
      call sm_xlabel_('Wavelength (A)')
      
      
      call sm_alpha_	   
      call sm_device_('x11')
      



      
C--------------------------------------------- EW variations due to continuum varations
      if(conter.eq.0.or.conter.eq.1)then
      
      d1min=1000.
      d1max=-1000.
      d2min=1000.
      d2max=-1000.
      do i=1,inl
      
       if(mysave3(i).ne.0.)then
        if((mysave2(i)-mysave3(i)).lt.d1min)
     &      d1min=mysave2(i)-mysave3(i)
        if((mysave2(i)-mysave3(i)).gt.d1max)
     &      d1max=mysave2(i)-mysave3(i)
       endif
	
       if(mysave4(i).ne.0.)then
        if((mysave2(i)-mysave4(i)).lt.d2min)
     &      d2min=mysave2(i)-mysave4(i)
        if((mysave2(i)-mysave4(i)).gt.d2max)
     &      d2max=mysave2(i)-mysave4(i)
       endif
	
      enddo
      
            
      if(d1min.le.d2min)dmin=d1min+0.2*d1min
      if(d1min.gt.d2min)dmin=d2min+0.2*d2min
      if(d1max.ge.d2max)dmax=d1max+0.2*d1max
      if(d1max.lt.d2max)dmax=d2max+0.2*d2max
      
      
      jnl=1
      do i=1,inl
        if(mysave3(i).ne.0.)then
	  a_mysave1(jnl)=mysave1(i)
	  a_mysave2(jnl)=mysave2(i)
	  a_mysave3(jnl)=mysave3(i)
	  jnl=jnl+1
	endif
      enddo
      jnl=jnl-1
      
      !
      
      knl=1
      do i=1,inl
        if(mysave4(i).ne.0.)then
	  b_mysave1(knl)=mysave1(i)
	  b_mysave2(knl)=mysave2(i)
	  b_mysave4(knl)=mysave4(i)
	  knl=knl+1
	endif
      enddo
      knl=knl-1
      
      
      call sm_ctype_('black')	   
      call sm_device_('postencap _tmp_pm.ps')
      call sm_graphics_
      call sm_expand_(0.8)
      call sm_lweight_(3.0)
      
      call sm_expand_(0.8)
      call sm_lweight_(3.0)
      call sm_location_(3500,30000,3500,15500)      
      call sm_limits_(ewmini,ewmaxi,dmin,dmax)
      call sm_box_(1,2,0,0) 
      call sm_expand_(1.3)
      call sm_xlabel_('EW (mA)')
      call sm_ylabel_('delta EW (mA)')
      call sm_ltype_(2)
      call sm_relocate_(-100.,0.)
      call sm_draw_(1.e6,0.)
      call sm_ltype_(0)
      call sm_ptype_(303.,1)
      call sm_points_(a_mysave2,(a_mysave2-a_mysave3),jnl)
      call sm_ctype_('red')
      call sm_points_(b_mysave2,(b_mysave2-b_mysave4),knl)
     
     
      call sm_ctype_('black')	   
      call sm_expand_(0.8)
      call sm_lweight_(3.0)
      call sm_location_(3500,30000,18000,30000)
      call sm_limits_(wmini,wmaxi,dmin,dmax)
      call sm_box_(1,2,0,0) 
      call sm_expand_(1.3)
      call sm_xlabel_('Wavelength (A)')
      call sm_ylabel_('delta EW (mA)')
      call sm_ltype_(2)
      call sm_relocate_(0.,0.)
      call sm_draw_(1.e6,0.)
      call sm_ltype_(0)
      call sm_ptype_(303.,1)
      call sm_points_(a_mysave1,(a_mysave2-a_mysave3),jnl)
      call sm_ctype_('red')
      call sm_points_(b_mysave1,(b_mysave2-b_mysave4),knl)
     
     
      call sm_alpha_	   
      call sm_device_('x11')
      
      endif
      




400   continue            
      
      
      end subroutine 
